;*********************************************
;        
;(    ""9, 2006.)
;:
;-  (Tiny2313  AT90s2313);
;-    2-  3-,
;    - 63;
;-    ;
;- (  )  .
;*********************************************
; FUSE   ATiny2313:
; (  "0") :
;"CKDIV", "SUTO", "CKSEL0".
;*********************************************
;
.INCLUDE "C:\1\tn2313def.inc"   ;   
                                ;   tn2313def.inc , 
                                ;HEX-   
;------------------------------------------------
;			  
;------------------------------------------------
;PORT B
.equ	plus	=0b00000001;(PB0-), "+"
.equ	minus	=0b00000010;(PB1-), "-"
.equ	nast	=0b00000100;(PB2-), ""
.equ	mask	=plus+minus+nast; 
.equ	shim	=3;(3[- 1]-), 
.equ	mx1	=4;(PB4-), 1
.equ	mx2	=5;(PB5-), 2
.equ    dmx =6;(PB6-),  (   )
.equ	blok	=7;(PB7-), 
;PORT D
;  PD0(2),PD1(3),PD2(6),PD3(7)   
;7("1"),1("2"),2("4"),6("8")  CD4511B 
.equ	anod1	=4;(PD4-),  '1'
.equ	anod2	=5;(PD5-),  '10'
.equ	anod3	=6;(PD6-),  '100'
.equ	chmask	=0b00000011;  
;
;------------------------------------------------
;			 
;------------------------------------------------
.equ	chanmax	=63	;.  
.equ	chanmin	=1	;.  
.equ	smesh	=0x18	;  
.equ	period	=10	;  
;                      -5 (200)
.equ	deg		=15;    ..-
;                     .
.equ	tun		=0; .   ( .
;                  )
.equ	nomch	=8;  ( .  )
.equ	time	=40;  (x50)
.equ	time1	=100;   (x50)
.equ    timeindst=255;   
;( : "1" - 1, "2" - 2, "3" - )
;
;------------------------------------------------
;		  ()
;------------------------------------------------
.def	w		=r16;-""
.def	tmp1	=r17; 
.def	tmp2	=r18; 
.def	flagind	=r19;  "1" -  
.def	stHG	=r20;.  HG
.def	razind	=r21;  
.def	speed	=r22;   
.def	chan_H	=r1	;   HEX	
.def	chan_D	=r2	;   DEC
.def	shim_st	=r3	;   
.def	shim_ml	=r4	;   
.def	adres	=r5	;   EEPROM 
.def	timest	=r6	;.  
.def	timeml	=r7	;.  
.def    countind=r23;   
;                    
.def    regim   =r24;    
;------------------------------------------------
;
.CSEG
;
.ORG	0
		rjmp	begin	;  
;
.ORG	OVF0addr
		rjmp	ind	;  - 
					;(  0)
;
;================================================
;   .
;================================================
;
	begin:	CLI	;| 
;			
			ldi	w,0xDF	;|  
			out	SPL,w	;|  
;
			ldi	w,0b00000100; 0 = /256
			out	TCCR0,w	;
;
			ldi	w,0xFF-period	;|  => 0
			out	TCNT0,w	;|
;
			ldi	w,2		;|    0
			out	TIMSK,w	;|
;
			ldi	w,0b11000011;|1   10  
			out	TCCR1A,w	;|"0"  1  ,
							;|"1"  1    1
;
			ldi	w,0b00000001;| 1 
			out	TCCR1B,w	;|  
;
			ldi	w,0b11111000;|  
			out	DDRB,w	;|
			ldi	w,0xCF	;|  0b11001111, .  1
			out	PORTB,w	;|
			ldi	w,0b01111111
			out DDRD,w
;
			ldi	razind,0 ;   HG  ..
			ldi	flagind,1;  
			clr countind;   
;                           						
			ldi regim,deg;    () 
			SEI	;| 
;
;**********************************************************
;			                  
;**********************************************************
;
			ldi	w,0		;   
			mov	adres,w	; "0"  EEROM
			rcall	read;
				cpi	w,chanmax+1	;   
				brcc	m3		;     chanmax
				tst	w			;     =0
				brne	m4		;0<<chanmax -   	
			m3:	ldi	w,1			; =1
		m4:	mov	chan_H,w;  HEX
			rcall	hexdec;  DEC
					mov	w,chan_H; . 
					lsl	w		; 
					mov	tmp1,w
					mov	adres,w
					rcall	read
					mov	shim_ml,w;
					dec	tmp1	 ; . 
					mov	adres,tmp1
					rcall	read
					mov	shim_st,w	;
					andi w,chmask	;   
				out	OCR1AH,w	   ;   .  
				out	OCR1AL,shim_ml ;   .  
;--------------------------------------
;    ( )
	press:	ldi	regim,deg; .  .
	press2:	in	 w,PINB	; 
			com	 w		; 
			andi w,mask
			brne	press2
			rcall	paus5
			;
		press1:	in	 w,PINB	;  
				com	 w		;
				andi w,mask
					cpi	 w,plus	;	
					breq chplus	;    
					cpi	 w,minus		
					breq chminus;    
					cpi	 w,nast		
					breq chnast	;   
					rcall	paus5
				rjmp press1
;--------------------------------------
;   .
		chplus:		rcall	paus50
			lab1:	ldi	w,chanmax	; =chanmax 
					cp	chan_H,w	;=chanmin  	
					brne	lab2	;  
					ldi	w,chanmin	; .
					mov	chan_H,w
					rjmp	lab3
			lab2:	inc	chan_H	;  
				lab3:	rcall	rdnast; .
							mov	w,shim_st	; 
							andi	w,chmask; .
							cpi	w,0x03
							brne	fiks	;   -
							ldi	w,0xFF		;  ,
							cp	shim_ml,w	; -
							brne	fiks	;  .
						ldi	w,chanmin	; =1,
						cp	chan_h,w	;    
						breq fiks	;  .
						rjmp	lab1
			fiks:	sbi	PORTB,blok;   .
					mov	w,shim_st	;|   
					andi	w,chmask;|
					out	OCR1AH,w ;   . .
					out	OCR1AL,shim_ml ;   . .
					rcall	hexdec;   chan_D
					ldi	w,0x0	;|     "0"
					mov	adres,w	;|   
					mov	w,chan_H;| .
					rcall	write
					rcall	paus100;|  .
					rcall	paus50;|
					cbi	PORTB,blok;   .
				ldi countind,0
				rjmp	press


;--------------------------------------
;   
		chminus:rcall	paus50
			lab4:	ldi	w,chanmin	; =chanmin 
					cp	chan_H,w	;=chanmax  	
					brne	lab5	;  
					ldi	w,chanmax	; .
					mov	chan_H,w
					rjmp	lab6
			lab5:	dec	chan_H	;  
				lab6:	rcall	rdnast; .
							mov	w,shim_st	; 
							andi	w,chmask; .
							cpi	w,0x03
							brne	fiks	;   -
							ldi	w,0xFF		;  ,
							cp	shim_ml,w	; -
							brne	fiks	;  .
						ldi	w,chanmin	; =1,
						cp	chan_h,w	;    
						breq	fiks	;  .
						rjmp	lab4
				ldi countind,0
				rjmp fiks


;--------------------------------------
;    
	chnast:	ldi	regim,tun;  
	   lab8:in	 w,PINB	; 
			com	 w		; 
			andi w,mask
			brne	lab8
		cikl1:	cpi speed,time1;  time1 ,
				brsh	spmax ;-  max .
				cpi speed,time;  time ,
				brsh	spbol ;-   .
				rcall	paus50
		spbol:	rcall	paus50
				inc	speed
			spmax:	rcall	paus20
					in	 w,PINB	;  
					com	 w		;
					andi w,mask
						cpi	 w,plus	;	
						breq nastplus ;   
						cpi	 w,minus		
						breq nastminus;   
						cpi	 w,nast		
						breq nastchan	;  
										;   .
				ldi speed,0
			rjmp	cikl1
;--------------------------------------
;   .
		nastplus:	mov	w,shim_ml  ;  
					cpi	w,0xFF     ;shim_ml ?
					breq MM1       ;
					inc shim_ml    ;  - .  1 shim_ml
			UST:	rcall zapis    ;   ,
		   	        rjmp cikl1     ;   
   	  MM1:  mov w,shim_st          ; ,  shim_ml=MAX,
	        andi w,0b00001111      ;  
            cpi w,0x0B             ;shim_st   -   ?
			breq MERC              ;    
			andi w,0b00000011      ; shim_st=MAX,   - 
			cpi w,0x03             ; ,   2 
			breq MM2               ;shim_st, a shim_ml= 
			clr shim_ml            ; shim_ml
			rjmp MM3               ;
      MM2:  ldi w,smesh            ;
		    mov shim_ml,w          ;
       MM3: inc shim_st            ;
		    rjmp UST               ;
   	MERC:   ldi	flagind,0          ;  
			rcall paus100
			ldi	flagind,1
			rcall paus100
			rjmp cikl1
;--------------------------------------
;   .
		nastminus:  mov w,shim_ml  ; shim_ml=smesh, ..
		  	        cpi w,smesh    ; MIN  shim_st=00,
			     breq S2           ;  S2
				 tst shim_ml       ;
				 brne S1           ;
				 ldi w,0xFF        ; shim_ml =0,  
			     mov shim_ml,w     ;shim_ml MAX = FF
				 dec shim_st       ;
				 rjmp UST          ;
		   S1: dec shim_ml         ;
			  	  rjmp UST         ;
			S2: mov w,shim_st      ; ,  shim_ml=smesh,
			    andi w,0b00001111  ;   shim_st=0000, ..
				tst w              ; 1,   
			    breq MERC          ;=00,    
				mov w,shim_st      ; 
				andi w,0b00000011  ;
				tst w              ;
				brne S1            ;
				dec shim_st        ;
			    ldi w,0xFF         ;
			    mov shim_ml,w      ;
			    rjmp UST		   ;	 	  	
	 ;
		 zapis:	mov	w,shim_st	;
				andi w,chmask	;   
				out	OCR1AH,w	   ;   .  
				out	OCR1AL,shim_ml ;   .  
				ret
;--------------------------------------
;      -.
		nastchan:ldi regim,nomch;   
				 		in	 w,PINB	;  
						com	 w		;
						andi w,mask
					cpi	 w,plus+nast	;	
					breq cplus	;   
					cpi	 w,minus+nast		
					breq cminus;   
					cpi	 w,nast		
					brne sohran	;  
					rcall	paus20
				 rjmp	nastchan
;
;  
		cplus:	inc chan_H
				ldi w,chanmax
				cp w,chan_H;   ?
				brsh chmen40;-
				ldi w,chanmin	;-,  =chanmin
				mov chan_H,w
		chmen40:rcall hexdec;  . 	
					in	 w,PINB	;  
						com	 w			;
						andi w,mask		;
					cpi	 w,plus+nast	;	
					breq chmen40		;
					rjmp nastchan
;
;  
		cminus:	dec chan_H
				ldi w,chanmin
				cp chan_H,w;   ?
				brsh chbol1;-
				ldi w,chanmax ;-,  =chanmax
				mov chan_H,w
		chbol1:	rcall hexdec;  . 	
					in	 w,PINB	;  
						com	 w		;
						andi w,mask
					cpi	 w,minus+nast		
					breq chbol1;
					rjmp nastchan
	;
;    
		sohran:	ldi w,0;   
				mov	adres,w;   (.0)
				mov	w,chan_H
				rcall write
					mov	w,chan_H;  
					lsl w		;   EEROM
						push w
							mov adres,w
							mov	w,shim_ml
							rcall write
						pop w
					dec w
					mov adres,w
					mov w,shim_st
					andi w,0b00001111
					rcall write
				rjmp press
;--------------------------------------
;  HEX=>DEC
;-chan_H, -chan_D
;: chan_D<100
;
			hexdec:	clr	tmp1
					mov	w,chan_H
					mov	tmp2,w
			um10:	ldi	w,0x0A
					sub	tmp2,w
					brcc	nt
					add	tmp2,w
					add	tmp2,tmp1
					mov	chan_D,tmp2
					ret
			nt:	ldi	w,0x10
				add	tmp1,w
				rjmp	um10
;--------------------------------------
;   EEPROM  
;:adres- .,:w- 
;
			read:	out	EEAR,adres
					sbi	EECR,EERE
					in	w,EEDR
					ret
					;
;--------------------------------------
;   EEPROM
;:adres- .,w- 
;
			write:	cli
					out	EEAR,adres
					out	EEDR,w
					sbi	EECR,EEMPE      ;  Tiny2313
					sbi	EECR,EEPE       ;  Tiny2313
					sei
				gdem:	in	w,EECR	;| 
						sbrs w,1	;| 
						ret
						rjmp	gdem
					;
;--------------------------------------
;   
;  
;:chan_H- ,
;:shim_st-. ,
;	   shim_ml-. 
;
			rdnast:	mov	adres,chan_H
					lsl	adres
					rcall	read
					mov	shim_ml,w
					dec	adres
					rcall	read
					andi	w,0b00001111
					mov	shim_st,w
					ret
;
;--------------------------------------
; 
;
;  5
		paus5:	push	w
				ldi	w,2
				mov	timest,w
				ldi	w,3
				mov	timeml,w
				rjmp	delay
;  20
		paus20:	push	w
				ldi	w,2
				mov	timest,w
				ldi	w,0x66
				mov	timeml,w
				rjmp	delay
;  50
		paus50:	push	w
					rcall	paus20
					rcall	paus20
					rcall	paus5
					rcall	paus5
				pop	w
				ret
;  100
		paus100:push	w
					rcall	paus50
					rcall	paus50
				pop	w
				ret
;
		delay: 	mov	tmp1,timeml
			timed:	rcall	delay8;| 
					rcall	delay8;|  (58) 40 
					rcall	delay8;| 
					rcall	delay8;|
					rcall	delay8;|
				tst	timeml
				breq	m1
				dec		timeml
				rjmp	timed
			m1:	tst	timest
				breq	m2
				dec	timest
				ldi	w,0xFF
				mov	timeml,w
				rjmp	timed
			m2:	pop	w
				ret
					delay8:	rcall	del8
					del8:	ret
					
;--------------------------------------
;   
;(     0
;  5)
			ind:push	w	;|    w
				in	w,SREG	;| SREG ()
				push	w	;|
					sbi	PORTD,anod1;  
					sbi	PORTD,anod2;
					sbi	PORTD,anod3;
					tst	flagind	;  "0" 
					breq straz	;  , 
						andi	razind,0b00000011;
							tst	razind			; 
							breq	mlraz		;
							cpi	razind,1
							breq	srraz
							cpi	razind,2
							breq	straz
						ldi	razind,0
;
				mlraz:	mov	w,chan_D	; "1"
						andi	w,0b00001111
						ori	w,0b11100000
						out	PORTD,w
						rjmp	vihod
;
				srraz:	mov	w,chan_D	; "10"
						swap	w
						andi	w,0b00001111
						breq	vihod
						ori	w,0b11010000
						out	PORTD,w
						rjmp	vihod
;
				straz:	mov	w,stHG	; "100"
						andi	w,0b00001111
						ori	w,0b10110000
						out	PORTD,w
						rjmp	vihod

			vihod:	inc	razind; . -.
					mov	w,shim_st	;, 
					andi w,0b00001100	;  2 ?
					cpi w,0x04
					breq  D2
		             cpi  w,0x08   ;   ?
			     	breq  D3
			      cbi PORTB,mx1  ;  1
			      sbi PORTB,mx2  ;
			      sbi PORTB,dmx  ;
			      mov w,regim  ;  -  ""
				  cpi w,tun    ;  "", 
				  breq B1      ;  
				  cpi w,nomch  ;               
				  breq C1      ;countind  timeindst
				  cpi countind,timeindst
				  breq A1
				  inc countind ;    .
			  B1: ldi stHG,1   ;1 -  1
				  rjmp Z1      ;
			  A1: ldi stHG,deg ;
			      rjmp Z1      ;
              C1: ldi stHG,nomch
			  Z1: rjmp lab7
			  D2: cbi PORTB,mx2   ;  2
			      sbi PORTB,mx1
			      sbi PORTB,dmx
			      mov w,regim
				  cpi w,tun
				  breq B2
				  cpi w,nomch
				  breq C2
				  cpi countind,timeindst
				  breq A2
				  inc countind
		   	  B2: ldi stHG,2 ;2 -  2
				  rjmp Z2
			  A2: ldi stHG,deg
			      rjmp Z2
              C2: ldi stHG,nomch
			  Z2: rjmp lab7   	
			  D3: cbi PORTB,dmx  ;  
			      sbi PORTB,mx1
			      sbi PORTB,mx2
			      mov w,regim
				  cpi w,tun
				  breq B3
				  cpi w,nomch
				  breq C3
				  cpi countind,timeindst
				  breq A3
				  inc countind
			  B3: ldi stHG,3      ;3 -  
				  rjmp Z3
			  A3: ldi stHG,deg
                  rjmp Z3
              C3: ldi stHG,nomch
			  Z3: rjmp lab7 			     	
		  	lab7:	ldi	w,0xFF-period; 0 - 
				out	TCNT0,w		 ;  .  .
			pop	w	;   
			out	SREG,w
			pop	w
		reti
.EXIT






